#ifndef __INOUT
#define __INOUT

#include "max/outlet.js"

var _inlets;
var _outlets;

function _in(channels) {
  inlets = channels.length;
  _inlets = {};
  _inlet_map = {};
  for (var i = 0; i < channels.length; i++) {
    var channel = channels[i];
    var func = channel[0];
    _inlets[i] = func;
    setinletassist(i | 0, channel[1]);
  };
};

function _out(channels) {
  outlets = channels.length;
  _outlets = {};
  for (var i = 0; i < channels.length; i++) {
    _outlets[channels[i][0]] = i;
    setoutletassist(i, channels[i][1]);
  }
};

function anything(_) {
  if (inlet in _inlets)
    return _inlets[inlet].apply(this, arrayfromargs(arguments));
  else
    post("Couldn't understand message", inlet, '\n');
};


#endif  // __INOUT
