#include "morse/queue.js"

Testing.TestFunction(function() {
  var queue = new Morse.Queue();
  queue.Set('');
  Testing.ExpectEqual('morse/queue', queue.queue, '');
  Testing.ExpectEqual('morse/queue', queue.display, '');

  queue.Set('tst');
  Testing.ExpectEqual('morse/queue', queue.queue, 'tst');
  Testing.ExpectEqual('morse/queue', queue.display, 'tst');

  var ch = queue.Pop();
  Testing.ExpectEqual('morse/queue', ch, 't');
  Testing.ExpectEqual('morse/queue', queue.previous_character, ch);
  Testing.ExpectEqual('morse/queue', queue.queue, 'st');
  Testing.ExpectEqual('morse/queue', queue.display, 'tst');

  ch = queue.Pop();
  Testing.ExpectEqual('morse/queue', ch, 's');
  Testing.ExpectEqual('morse/queue', queue.queue, 't');
  Testing.ExpectEqual('morse/queue', queue.display, 'st');

  ch = queue.Pop();
  Testing.ExpectEqual('morse/queue', ch, 't');
  Testing.ExpectEqual('morse/queue', queue.queue, '');
  Testing.ExpectEqual('morse/queue', queue.display, 't');

  ch = queue.Pop();
  Testing.ExpectEqual('morse/queue', ch, '');
  Testing.ExpectEqual('morse/queue', queue.queue, '');
  Testing.ExpectEqual('morse/queue', queue.display, '');
});
