#ifndef __PATCH
#define __PATCH

#include "patch/bank_pc.js"

function Patch(map) {
  map = map || {};

  this.BankPC = function(program_change_map) {
    return new BankPC(program_change_map);
  };

  this.Change = function(midiout, program) {
    return map[midiout].Patch(program);
  };

  this.SetMap = function(m) {
    map = m;
  };
};

#endif  // __PATCH
