#ifndef __INPUT
#define __INPUT

function Input() {
  this.input_map = {};
  var me = this;

  this.context = {
    'SetMap': function(map) {
      me.input_map = map;
    },

    'Mod': function(mod) {
      return function(value) { return [value % mod]; };
    },

    'NamedMod': function(mod, names) {
      return function(ctr, value) {
        return [names[(ctr / mod) | 0], ctr % mod, value];
      };
    },
  };

  this.MapInput = function(input) {
    var name = input[0];
    if (name in me.input_map)
      input = [name].concat(me.input_map[name].apply(this, input.slice(1)));
    return input;
  };
};

#endif  // __INPUT
