#include "util/reader.js"
#include "state/input.js"

Testing.TestFunction(function() {
  var input = new Input();
  input.context.Input = input.context;
  input.input_map = Reader.ReadData('js/state/input_map_test.data',
                                    input.context);

  Testing.ExpectEqual('input', input.MapInput(['wombat', 23]), ['wombat', 23]);

  Testing.ExpectEqual('input', input.MapInput(['pedal', 23]), ['pedal', 3]);

  Testing.ExpectEqual('input', input.MapInput(['nano', 6, 40]),
                      ['nano', 'slider', 6, 40]);
  Testing.ExpectEqual('input', input.MapInput(['nano', 35, 45]),
                      ['nano', 'bottom', 5, 45]);
  });

