#ifndef __UTIL_DEFER
#define __UTIL_DEFER

function Defer(fn) {
  return function(_) {
    var args = arrayfromargs(arguments);
    return function() {
      fn.apply(this, args);
    };
  };
};

#endif  // __UTIL_DEFER
