#ifndef __SONGS
#define __SONGS

function Map(map) {
  return function(x) {
    return map[x];
  };
};

function Compose(functions) {
  var f = function(x) {
    for (var f in functions)
      x = f(x);
    return x;
  };
  f.functions = functions;
  f.name = functions.name;
  return f;
};

// A Scene is a list of commands to apply to a state - it's just
// a composition.
Scene = Circulate(0);
Section = Circulate(1);
Song = Circulate(2);
Set = Circulate(3);
SetSet = Circulate(4);

#endif  // __SONGS
