#ifndef __SUBSTITUTE
#define __SUBSTITUTE

#include "clone.js"

function _substitute(map, subs) {
  map = _clone.clone(map);
  for (var i in subs) {
    var sub = subs[i];
    var s = map;
    var address_len = sub.length - 2;
    for (var j = 0; j < address_len; ++j)
      s = s[sub[j]];

    var location = sub[address_len];
    var value = sub[address_len + 1];
    if (value == null)
      delete s[location];
    else
      s[location] = value;
  }
  return map;
};

#endif  // __SUBSTITUTE
