function test_songs() {
  var scenes = _set_song_test_data();
  var reset = scenes[0].slice(1);
  var scene2 = scenes[1].slice(1);
  _test_equal('scene_list', _scene_list,
              [0,
               [['reset', 'spirit'],
                ['scene2', 'spirit'],
                ['reset', 'spirit2']],
               ]);
  _test_equal('song_table', _song_table,
              {'spirit':  {'reset': reset, 'scene2': scene2},
               'spirit2': {'reset': reset}});
};

function _set_song_test_data() {
  function action1() { _results.push('action1'); }
  function action2() { _results.push('action2'); }
  function action3() { _results.push('action3'); }
  var reset = ['reset', [action1]];
  var scene2 = ['scene2', [action2], [action3]];
  var spirit = ['spirit', reset, scene2];
  var spirit2 = ['spirit2', reset];

  _set_song_data([spirit, spirit2]);
  return [reset, scene2, spirit];
};
