#include "creator/builder.js"
#include "creator/write_builder.js"
#include "creator/builder_from_patcher.js"
#include "util/reader.js"

autowatch = 1;

var _builder;

function inputfile(filename) {
  var data = Reader.ReadData(filename);
  _builder = Creator.BuilderFromPatcher(data);
};

function outputfile(filename) {
  var out = new File(filename, 'write');
  Max.WriteBuilder(_builder, function(x) {
    out.writestring(x);
  });
  out.close();
};

function create(x, y) {
  Max.CreateAndConnect(_builder, {'x': x | 0, 'y': y | 0});
};

post('recompiled clone_patcher.\n');
