#include "command/vl.js"

VL.program_changes = {
 'Trumpet':  [1, 1],
 'Maynard':  [1, 2],
 'Alpert':   [1, 3],
 'Chet_Tpt': [1, 4],
 'Lead_Tpt': [1, 5],
 'ClassTpt': [1, 6],
 'StrMtTpt': [1, 7],
 'CupMtTpt': [1, 8],
 'WahMtTpt': [1, 9],
 'WaTptCC4': [1, 10],
 'HrmMtTpt': [1, 11],
 'Mute_Tpt': [1, 12],
 'Picc_Tpt': [1, 13],
 'Cornet':   [1, 14],
 'Flugel':   [1, 15],
 'Mangione': [1, 16],
 'Trombone': [1, 17],
 'Big_Bone': [1, 18],
 'BriteTbn': [1, 19],
 'ValveTbn': [1, 20],
 'Jam_Bone': [1, 21],
 'Bass_Tbn': [1, 22],
 'BcktMtTb': [1, 23],
 'DorseyTb': [1, 24],
 'WX_Horn':  [1, 25],
 'BrassHrn': [1, 26],
 'BriteHrn': [1, 27],
 'ff_Horn':  [1, 28],
 'OrchHorn': [1, 29],
 'New_Horn': [1, 30],
 'Euphnium': [1, 31],
 'Tuba':     [1, 32],
 'SoprnoSx': [1, 33],
 'KennyGee': [1, 34],
 'HeyKenG_': [1, 35],
 'Branford': [1, 36],
 'TraneSop': [1, 37],
 'BrtSopSx': [1, 38],
 'Alto_Sax': [1, 39],
 'Sanborn':  [1, 40],
 'BirdAlto': [1, 41],
 'ExprAlto': [1, 42],
 'Desmond':  [1, 43],
 'Koz_Alto': [1, 44],
 'Everette': [1, 45],
 'NY_Alto':  [1, 46],
 'NY_Tenor': [1, 47],
 'TenorSax': [1, 48],
 'MBrecker': [1, 49],
 'PopTenor': [1, 50],
 'SoulTenr': [1, 51],
 'RaspyTnr': [1, 52],
 'Getz_Tnr': [1, 53],
 'JobimTnr': [1, 54],
 'TenorSub': [1, 55],
 'Bari_Sax': [1, 56],
 'TiteBari': [1, 57],
 'Sax_Sect': [1, 58],
 'Air_Sax':  [1, 59],
 'Saxual':   [1, 60],
 'Sanford':  [1, 61],
 'Piccolo':  [1, 62],
 'Flute':    [1, 63],
 'Real_Flt': [1, 64],
 'SilvrFlt': [1, 65],
 'ClassFlt': [1, 66],
 'Nz_Flute': [1, 67],
 'VoxFlute': [1, 68],
 'AquaFlut': [1, 69],
 'OakFlute': [1, 70],
 'Bass_Flt': [1, 71],
 'Afri_Flt': [1, 72],
 'PennyWhs': [1, 73],
 'TinWhist': [1, 74],
 'Flutofon': [1, 75],
 'Inca_Flt': [1, 76],
 'Noze_Flt': [1, 77],
 'Quena':    [1, 78],
 'Quena_x2': [1, 79],
 'PanFlute': [1, 80],
 'Andean':   [1, 81],
 'Pan_Pipe': [1, 82],
 'Bali_Flt': [1, 83],
 'IndiaFlt': [1, 84],
 'Ambience': [1, 85],
 'WetFone':  [1, 86],
 'Maya_Flt': [1, 87],
 'Shakuhat': [1, 88],
 'Bamboo':   [1, 89],
 'PanPicol': [1, 90],
 'Coca__':   [1, 91],
 'Ocarina_': [1, 92],
 'Lonely':   [1, 93],
 'Recorder': [1, 94],
 'Clarinet': [1, 95],
 'JazzClar': [1, 96],
 'ClsClrnt': [1, 97],
 'Bs_Clrnt': [1, 98],
 'BrtBsClr': [1, 99],
 'Oboe':     [1, 100],
 'Eng_Horn': [1, 101],
 'SftEngHn': [1, 102],
 'Bassoon':  [1, 103],
 'Flurinet': [1, 104],
 'Crumbon':  [1, 105],
 'Klarina':  [1, 106],
 'ThaiReed': [1, 107],
 'Chanter':  [1, 108],
 'Digirdoo': [1, 109],
 'IslePipe': [1, 110],
 'SoftPipe': [1, 111],
 'LitePipe': [1, 112],
 'CelloSax': [1, 113],
 'YamaBotl': [1, 114],
 'Solo_Vln': [1, 115],
 'DrkVioln': [1, 116],
 'BrtVioln': [1, 117],
 'SweetVln': [1, 118],
 'Fiddle':   [1, 119],
 'Viola':    [1, 120],
 'SwtViola': [1, 121],
 'RosinVla': [1, 122],
 'Cello':    [1, 123],
 'SoloCell': [1, 124],
 'DrkCello': [1, 125],
 'Bow_Bass': [1, 126],
 'HiStrEns': [1, 127],
 'Pizzicat': [1, 128],
 'Harmonca': [2, 1],
 'MouthHrp': [2, 2],
 'BluesHrm': [2, 3],
 'Stevie_':  [2, 4],
 'Toots_':   [2, 5],
 'Accordn_': [2, 6],
 'Concrtna': [2, 7],
 'Jazz_B3':  [2, 8],
 'Clavinet': [2, 9],
 'Funky':    [2, 10],
 'SteelDrm': [2, 11],
 'VL_Drums': [2, 12],
 'Yangchin': [2, 13],
 'Asia_Plk': [2, 14],
 'JapanPlk': [2, 15],
 'Tambura':  [2, 16],
 'Sitar':    [2, 17],
 'ElecHarp': [2, 18],
 'SteelGtr': [2, 19],
 'AcGuitar': [2, 20],
 'Flamenco': [2, 21],
 'SpainGtr': [2, 22],
 'NylonGtr': [2, 23],
 'SwtNylGt': [2, 24],
 'Les_Gtr':  [2, 25],
 'Joe_Pass': [2, 26],
 'FMGuitar': [2, 27],
 'Lucille':  [2, 28],
 '__PAT__':  [2, 29],
 'EFXStrat': [2, 30],
 'ClnStrat': [2, 31],
 'Surf_Gtr': [2, 32],
 'Mute_Gtr': [2, 33],
 'WahGtCC4': [2, 34],
 'PatSynGt': [2, 35],
 'BluesGtr': [2, 36],
 'Clapton':  [2, 37],
 'PopODGtr': [2, 38],
 'Carlos':   [2, 39],
 'TubeGtr_': [2, 40],
 'FET_Guit': [2, 41],
 'Dist_Gtr': [2, 42],
 'Wah_Lead': [2, 43],
 'Wah_Dist': [2, 44],
 'GuitHero': [2, 45],
 'Eddie4th': [2, 46],
 'Feedback': [2, 47],
 'Hendrix':  [2, 48],
 'TalkBox_': [2, 49],
 '_XTREME_': [2, 50],
 'Hercules': [2, 51],
 'SynClav':  [2, 52],
 'Syncro':   [2, 53],
 'Theremin': [2, 54],
 'Avalana':  [2, 55],
 'Voxanne':  [2, 56],
 'Beauty':   [2, 57],
 'SpaceOut': [2, 58],
 'Ghost_Ld': [2, 59],
 'PtchNoiz': [2, 60],
 'BreathTb': [2, 61],
 'Air_Lead': [2, 62],
 'Breezer':  [2, 63],
 'ZawiLead': [2, 64],
 'Voxofone': [2, 65],
 'Whistler': [2, 66],
 'Debussy':  [2, 67],
 'Sines':    [2, 68],
 'SmoothLd': [2, 69],
 'Slinky':   [2, 70],
 'AirStick': [2, 71],
 'RotoFone': [2, 72],
 'Vox_Lead': [2, 73],
 'Squeezy':  [2, 74],
 'Lyricon':  [2, 75],
 'Ana_Lead': [2, 76],
 'Mobius':   [2, 77],
 '_70sLead': [2, 78],
 'Osc_Lead': [2, 79],
 'Saw_Lead': [2, 80],
 'SAWS':     [2, 81],
 'ResoSaws': [2, 82],
 'EML_Lead': [2, 83],
 'HPFilter': [2, 84],
 'EWI_ARP':  [2, 85],
 'EWI_Lead': [2, 86],
 'Koz_Lead': [2, 87],
 'MattLead': [2, 88],
 'PATCHMAN': [2, 89],
 'Taurus':   [2, 90],
 'Phaser':   [2, 91],
 'SynZilla': [2, 92],
 'MegaSyn':  [2, 93],
 'Winwood':  [2, 94],
 'Pulse_Ld': [2, 95],
 'Corea':    [2, 96],
 'SquareLd': [2, 97],
 'Korg_Ld':  [2, 98],
 'LuckyMan': [2, 99],
 'Lyle':     [2, 100],
 'Analog':   [2, 101],
 'Nyle':     [2, 102],
 'Floyd_Ld': [2, 103],
 'BorgHorn': [2, 104],
 'Freik':    [2, 105],
 'Fazar':    [2, 106],
 'Dungeon':  [2, 107],
 'NevrLand': [2, 108],
 'Brekord1': [2, 109],
 'Brekord2': [2, 110],
 'Brekord3': [2, 111],
 'ElecBass': [2, 112],
 'MotownBs': [2, 113],
 'SteinBas': [2, 114],
 'FunkBass': [2, 115],
 'PickBass': [2, 116],
 'SnapBass': [2, 117],
 'Thumb_Bs': [2, 118],
 'TiteBass': [2, 119],
 'JacoBass': [2, 120],
 'StratoBs': [2, 121],
 'Sticky':   [2, 122],
 'MuteBass': [2, 123],
 'Ac_Bass':  [2, 124],
 'Juicy_Bs': [2, 125],
 'GnarlyBs': [2, 126],
 'Moog_Bs':  [2, 127],
 'Bass1000': [2, 128],
 'BowedSaw': [4, 52],
 'ThaiReed': [4, 53],
 'Moby':     [4, 54],
 'Ossyncro': [4, 55],
 'Jurassic': [4, 56],
 'Formula':  [4, 57],
 'DinoPerc': [4, 58],
 'Waterphn': [4, 59],
 'Mu':       [4, 60],
 'YamSteel': [4, 61],
 'Sitar2':   [4, 62],
 'SmooBass': [4, 63],
 'SpaceZoo': [4, 64],
};
