autowatch = 1;

#include "command/all_cycles.js"
#include "max/clear_maxobjs.js"

function clear() {
  ClearMaxobjs('message', 'append', 'textedit', 'live.text');
};

var cycle_definition;

var table = [];
var context = {'x': 10, 'y': 10};
var cycles;

function init(x, y) {
  clear();
  cycles = new AllCycles(context, 18);
  post('initialized\n');
};

function up(level) {
  cycles.Advance(level);
};

function down(level) {
  cycles.Advance(level, -1);
};

function add(level) {
};

function remove(level) {
};

function text(name, level) {
  cycles.SetName(level, name);
};

Commander.PC = {
 0: function() { up(2); },
 1: function() { up(1); },
 2: function() { up(0); },
 3: function() { down(0); },
 4: function() { down(2); },
};

function pc(value) {
  (Commander.PC[value] || function() {})();
};

post('recompiled commander.jso\n');
