#include "max/callback.js"

Testing.TestFunction(function() {
  function TestClass() {
    this.x = 3;
    this.F = function(x, y, z) {
      return x + y + z;
    };
  };

  var object = new TestClass();
  var context = {};
  Callback.AddInlet(context, object, ['x', 'F']);

  var res1 = context.x(10);  // Sets x to 10.
  var res2 = context.x();  // Gets x.
  var res = context.f(1, 2, 3);  // Calls F(1, 2, 3);

  Testing.ExpectEqual('inlet_callback', object.x, 10);
  Testing.ExpectEqual('inlet_callback', res1, 10);
  Testing.ExpectEqual('inlet_callback', res2, 10);
  Testing.ExpectEqual('inlet_callback', res, 6);
});
