// This is the "top-level" Javascript file for the Morse generator - also
// intended to demonstrate a possible discipline for large Max/Javascript
// projects.
//
// A Javascript class called Morse.Generator does all the work.  A little functional
// magic with Javascript attaches members and methods on Morse.Generator to Max
// messages coming from the external world.

autowatch = 1;

#include "morse/generator.js"
#include "morse/callbacks.js"

Morse.AddCallbacks(new Morse.Generator(), this);

// Now the Max program needs to send an init message to initialize the values
// that cause data to be emitted from the outlets (because this can't be done
// during initialization).
