#ifndef __BANK_PC
#define __BANK_PC

function BankPC(table) {
  this.Patch = function(program) {
    var patch = table[program];
    if (!patch)
      throw new RangeError("Couldn't understand program " + program);

    var bank_changed = false;
    if (patch.length > 1) {
      var bank = patch[1];
      if (bank != undefined && bank != this.bank) {
        bank_changed = true;
        this.bank = bank;
        _outlet(0, ['midiout', 'cc', 32, this.bank]);
        // Well-known MIDI bank control CC 32.
      }
    }

    var pc = patch[0];
    if (bank_changed || pc != this.pc) {
      if (pc != undefined)
        this.pc = pc;
      if (this.pc != undefined && (bank_changed || pc != undefined))
        _outlet(0, ['midiout', 'pc', this.pc]);
    }
  }
};

#endif  // __BANK_PC
