#include "patch/bank_pc.js"

Testing.TestFunction(function() {
  var b = new BankPC({'foo': [35, 0], 'bar': [36, 0], 'baz': [36, 1]});

  Testing.results = [];
  b.Patch('foo');
   Testing.ExpectEqual('bank_pc', Testing.results,
                      [[0, 'midiout', 'cc', 32, 0],
                       [0, 'midiout', 'pc', 35]]);

  Testing.results = [];
  b.Patch('bar');
  Testing.ExpectEqual('bank_pc', Testing.results,
                      [[0, 'midiout', 'pc', 36]]);

  Testing.results = [];
  b.Patch('baz');
  Testing.ExpectEqual('bank_pc', Testing.results,
                      [[0, 'midiout', 'cc', 32, 1],
                       [0, 'midiout', 'pc', 36]]);
});
