#ifndef __DICT_UTILS
#define __DICT_UTILS

var DictUtils = new Object();

DictUtils.Keys = function(d) {
  var r = [];
  for (var i in d)
    r.push(i);
  return r;
};

DictUtils.GetOrAddDefault = function(table, key,  dflt) {
  if (key in table)
    return table[key];
  table[key] = dflt;
  return dflt;
};

DictUtils.Copy = function(dict) {
  var result = {};
  for (var name in dict)
    result[name] = dict[name];
  return result;
};

#endif  // __DICT_UTILS
