Testing.TestFunction(function() {
  Testing.ExpectFunction('is_array', Array.Is, this, [[1]], true);
  Testing.ExpectFunction('is_array', Array.Is, this, [[]], true);
  Testing.ExpectFunction('is_array', Array.Is, this, [[1, 2]], true);
  Testing.ExpectFunction('is_array', Array.Is, this, [{}], false);
  Testing.ExpectFunction('is_array', Array.Is, this, [{1:1}], false);
  Testing.ExpectFunction('is_array', Array.Is, this, [new Object()], false);

  function f(name, value) {
    Testing.results.push([name, value]);
  };

  Testing.ExpectFunction('is_array',
                         Array.ForEach, this, [f, [1, 2, 3]],
                         [[1, 1], [2, 2], [3, 3]], true);
  Testing.ExpectFunction('is_array',
                         Array.ForEach, this, [f, {1:'a', 2:'b'}],
                         [['a', 1], ['b', 2]], true);
  Testing.ExpectFunction('is_array',
                         Array.ForEach, this, [f, {1:'a', 2:'b'}, true],
                         [['1', 'a'], ['2', 'b']], true);
});

