#ifndef __GROUPS
#define __GROUPS

#include "circular.js"

function Groups(groups) {
  for (var i = 0; i < groups.length; ++i) {
    groups[i] = Circular(Named(groups[i]));
    for (var j = 0; j < groups[i].length; ++j)
      groups[i][j] = Circular(Named(groups[i][j]));
  };
  return Circular(groups);
};

Groups.GROUP = 0;
Groups.CATEGORY = 1;
Groups.PATCH = 2;

#endif  // __GROUPS
