#ifndef _INSTRUMENT
#define _INSTRUMENT

function Instrument(output_map, program_map) {
  this.set = function(outlet, instrument, patch) {
    if (!(instrument in program_map)) {
      post("ERROR: Can't find instrument", instrument, '\n');
      return;
    }

    var imap = program_map[instrument];
    if (!(patch in imap)) {
      post("ERROR: Can't find patch", patch, 'in instrument', instrument, '\n');
      return;
    }
    var value = imap[patch];
    if (!(value && value.length)) {
      post('ERROR: patch had empty value:', patch, '\n');
      return;
    }

    outlet(_CURRENT_INSTRUMENT, [instrument]);
    output_map[instrument](outlet, value);

    outlet(_DISPLAY, ['instrument', instrument]);
    outlet(_DISPLAY, ['program', patch]);
  };
};

#endif // _INSTRUMENT
