#ifndef __PROGRAM_CHANGES
#define __PROGRAM_CHANGES

#include "instrument.js"
#include "read_file.js"

function ProgramChanges() {
  this.program_change_map = {};

  var output_map = {'vl': new VLState().program_change};
  var program_map = _read_data('program_changes.data');
  var instrument_i = new Instrument(output_map, program_map);

  this.set = function(instrument, name) {
    instrument_i.set(instrument, name);
  };
};

#endif  // __PROGRAM_CHANGES
