#ifndef __REMOVE_MAXOBJS
#define __REMOVE_MAXOBJS

#include "max/patcher.js"

function RemoveMaxobjs(_) {
  var names = arrayfromargs(arguments);
  var to_remove = [];
  for (var obj = Max.patcher.firstobject; obj; obj = obj.nextobject) {
    if (names.indexOf(obj.maxclass) >= 0)
      to_remove.push(obj);
  }
  for (var i in to_remove)
    Max.patcher.remove(to_remove[i]);
};

#endif  // __REMOVE_MAXOBJS


